// determines indices (row numbers) of items by looking
// at item tags.  midterms are assumed to occupy consecutive
// lines in the input file, but the final, quizzes and
// homework lines may be in any order.  it returns the
// vector of indices.
// [this is not very compact code, but maybe it works.
// i could not think of a better way to do it.]
//
// the STL string compare function is different for g++ versions
// >= 3.0 from that for g++ versions < 3.0 as noted below
// the comparison done with C-style strings (strncmp) works
// for all versions of g++, so we use that here.
//
#include "mkevals.h"

vector<uns> get_item_indices(misc* mp)
{
    vector<uns> indx(mp->items);
    uns j;
    uns i = 0;

    for (j = 0 ; j < mp->tag.size() ; j++){
        if (mp->tag[j] == FIN){
            indx[i] = j;             // index of "final" item
            i++;
        }
    }
    if (mp->mids){                   // find indices for midterms
        for (j = 0 ; j < mp->tag.size() ; j++){
//            if (!(mp->tag[j].compare(MID, 0, MID.length()))){ //< 3.0
            if (!(strncmp(mp->tag[j].c_str(), MID.c_str(), MID.length()))){
//            if (!(mp->tag[j].compare(0, MID.length(), MID))){ //>=3.0
                for (uns k=0 ; k < mp->mids ; k++){
                    indx[i] = j+k;   // midterms are consecutive
                    i++;
                }
                break;  // necessary to exit loop at first match
            }
        }
    }
    if (mp->quizzes){                // find index for quiz item
        for (j = 0 ; j < mp->tag.size() ; j++){
            if (mp->tag[j] == QUIZ){
                indx[i] = j;         // index of "quizzes" item
                i++;
            }
        }
    }
    if (mp->hmwk){                   // find index for homework item
        for (j = 0 ; j < mp->tag.size() ; j++){
            if (mp->tag[j] == HMWK){
                indx[i] = j;         // index of "homework" item
                i++;
            }
        }
    }
    return indx;
}

